// A Bison parser, made by GNU Bison 3.5.1.

// Skeleton interface for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


/**
 ** \file quant_c_parse.hpp
 ** Define the quant_c_compiler::parser class.
 */

// C++ LALR(1) parser skeleton written by Akim Demaille.

// Undocumented macros, especially those whose name start with YY_,
// are private implementation details.  Do not rely on them.

#ifndef YY_YY_QUANT_C_PARSE_HPP_INCLUDED
# define YY_YY_QUANT_C_PARSE_HPP_INCLUDED
// "%code requires" blocks.
#line 12 "/home/tyler/code/C-C++/QuantC/code/quant_c.y"

    #include <unordered_map>
    #include <utility>
    #include "ast/ast.hpp"
    #include "token/token.hpp"

    // using namespace quant_c_ast;
    namespace quant_c_compiler {
        class Scanner;
    } // namespace quant_c_compiler

#line 60 "quant_c_parse.hpp"


# include <cstdlib> // std::abort
# include <iostream>
# include <stdexcept>
# include <string>
# include <vector>

#if defined __cplusplus
# define YY_CPLUSPLUS __cplusplus
#else
# define YY_CPLUSPLUS 199711L
#endif

// Support move semantics when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_MOVE           std::move
# define YY_MOVE_OR_COPY   move
# define YY_MOVE_REF(Type) Type&&
# define YY_RVREF(Type)    Type&&
# define YY_COPY(Type)     Type
#else
# define YY_MOVE
# define YY_MOVE_OR_COPY   copy
# define YY_MOVE_REF(Type) Type&
# define YY_RVREF(Type)    const Type&
# define YY_COPY(Type)     const Type&
#endif

// Support noexcept when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_NOEXCEPT noexcept
# define YY_NOTHROW
#else
# define YY_NOEXCEPT
# define YY_NOTHROW throw ()
#endif

// Support constexpr when possible.
#if 201703 <= YY_CPLUSPLUS
# define YY_CONSTEXPR constexpr
#else
# define YY_CONSTEXPR
#endif


#ifndef YY_ASSERT
# include <cassert>
# define YY_ASSERT assert
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

#line 7 "/home/tyler/code/C-C++/QuantC/code/quant_c.y"
namespace quant_c_compiler {
#line 195 "quant_c_parse.hpp"




  /// A Bison parser.
  class Parser
  {
  public:
#ifndef YYSTYPE
  /// A buffer to store and retrieve objects.
  ///
  /// Sort of a variant, but does not keep track of the nature
  /// of the stored data, since that knowledge is available
  /// via the current parser state.
  class semantic_type
  {
  public:
    /// Type of *this.
    typedef semantic_type self_type;

    /// Empty construction.
    semantic_type () YY_NOEXCEPT
      : yybuffer_ ()
    {}

    /// Construct and fill.
    template <typename T>
    semantic_type (YY_RVREF (T) t)
    {
      YY_ASSERT (sizeof (T) <= size);
      new (yyas_<T> ()) T (YY_MOVE (t));
    }

    /// Destruction, allowed only if empty.
    ~semantic_type () YY_NOEXCEPT
    {}

# if 201103L <= YY_CPLUSPLUS
    /// Instantiate a \a T in here from \a t.
    template <typename T, typename... U>
    T&
    emplace (U&&... u)
    {
      return *new (yyas_<T> ()) T (std::forward <U>(u)...);
    }
# else
    /// Instantiate an empty \a T in here.
    template <typename T>
    T&
    emplace ()
    {
      return *new (yyas_<T> ()) T ();
    }

    /// Instantiate a \a T in here from \a t.
    template <typename T>
    T&
    emplace (const T& t)
    {
      return *new (yyas_<T> ()) T (t);
    }
# endif

    /// Instantiate an empty \a T in here.
    /// Obsolete, use emplace.
    template <typename T>
    T&
    build ()
    {
      return emplace<T> ();
    }

    /// Instantiate a \a T in here from \a t.
    /// Obsolete, use emplace.
    template <typename T>
    T&
    build (const T& t)
    {
      return emplace<T> (t);
    }

    /// Accessor to a built \a T.
    template <typename T>
    T&
    as () YY_NOEXCEPT
    {
      return *yyas_<T> ();
    }

    /// Const accessor to a built \a T (for %printer).
    template <typename T>
    const T&
    as () const YY_NOEXCEPT
    {
      return *yyas_<T> ();
    }

    /// Swap the content with \a that, of same type.
    ///
    /// Both variants must be built beforehand, because swapping the actual
    /// data requires reading it (with as()), and this is not possible on
    /// unconstructed variants: it would require some dynamic testing, which
    /// should not be the variant's responsibility.
    /// Swapping between built and (possibly) non-built is done with
    /// self_type::move ().
    template <typename T>
    void
    swap (self_type& that) YY_NOEXCEPT
    {
      std::swap (as<T> (), that.as<T> ());
    }

    /// Move the content of \a that to this.
    ///
    /// Destroys \a that.
    template <typename T>
    void
    move (self_type& that)
    {
# if 201103L <= YY_CPLUSPLUS
      emplace<T> (std::move (that.as<T> ()));
# else
      emplace<T> ();
      swap<T> (that);
# endif
      that.destroy<T> ();
    }

# if 201103L <= YY_CPLUSPLUS
    /// Move the content of \a that to this.
    template <typename T>
    void
    move (self_type&& that)
    {
      emplace<T> (std::move (that.as<T> ()));
      that.destroy<T> ();
    }
#endif

    /// Copy the content of \a that to this.
    template <typename T>
    void
    copy (const self_type& that)
    {
      emplace<T> (that.as<T> ());
    }

    /// Destroy the stored \a T.
    template <typename T>
    void
    destroy ()
    {
      as<T> ().~T ();
    }

  private:
    /// Prohibit blind copies.
    self_type& operator= (const self_type&);
    semantic_type (const self_type&);

    /// Accessor to raw memory as \a T.
    template <typename T>
    T*
    yyas_ () YY_NOEXCEPT
    {
      void *yyp = yybuffer_.yyraw;
      return static_cast<T*> (yyp);
     }

    /// Const accessor to raw memory as \a T.
    template <typename T>
    const T*
    yyas_ () const YY_NOEXCEPT
    {
      const void *yyp = yybuffer_.yyraw;
      return static_cast<const T*> (yyp);
     }

    /// An auxiliary type to compute the largest semantic type.
    union union_type
    {
      // assignment_operator
      char dummy1[sizeof (int)];

      // BOOL_LITERAL
      char dummy2[sizeof (quant_c_token::BoolLitToken)];

      // CHAR_LITERAL
      char dummy3[sizeof (quant_c_token::CharLitToken)];

      // FLOAT_LITERAL
      char dummy4[sizeof (quant_c_token::FloatLitToken)];

      // IDENTIFIER
      char dummy5[sizeof (quant_c_token::IdentifierToken)];

      // INT_LITERAL
      char dummy6[sizeof (quant_c_token::IntLitToken)];

      // STRING_LITERAL
      char dummy7[sizeof (quant_c_token::StringLitToken)];

      // TYPE_NAME
      char dummy8[sizeof (quant_c_token::TypeNameToken)];

      // PTR_OP
      // INC_OP
      // DEC_OP
      // LEFT_OP
      // RIGHT_OP
      // LE_OP
      // GE_OP
      // EQ_OP
      // NE_OP
      // ADD_ASSIGN
      // AND_OP
      // OR_OP
      // MUL_ASSIGN
      // DIV_ASSIGN
      // MOD_ASSIGN
      // SUB_ASSIGN
      // LEFT_ASSIGN
      // RIGHT_ASSIGN
      // AND_ASSIGN
      // XOR_ASSIGN
      // OR_ASSIGN
      // ELLIPSIS
      // ';'
      // '{'
      // '}'
      // ','
      // ':'
      // '='
      // '('
      // ')'
      // '['
      // ']'
      // '.'
      // '&'
      // '!'
      // '~'
      // '-'
      // '+'
      // '*'
      // '/'
      // '%'
      // '<'
      // '>'
      // '^'
      // '|'
      // '?'
      // TYPEDEF
      // EXTERN
      // STATIC
      // AUTO
      // REGISTER
      // CHAR
      // SHORT
      // INT
      // LONG
      // SIGNED
      // UNSIGNED
      // FLOAT
      // DOUBLE
      // CONST
      // VOLATILE
      // VOID
      // STRUCT
      // UNION
      // ENUM
      // CASE
      // DEFAULT
      // IF
      // ELSE
      // SWITCH
      // WHILE
      // DO
      // FOR
      // GOTO
      // CONTINUE
      // BREAK
      // RETURN
      // SIZEOF
      // BOOL
      // QUANTUM
      // PSWAP
      // ISWAP
      // SWAP
      // X_GATE
      // Y_GATE
      // Z_GATE
      // HADAMARD
      // PHASE
      // S_GATE
      // T_GATE
      // RX
      // RY
      // RZ
      // INVERSE
      // CONTROL
      // MEASURE
      // IDENTITY
      char dummy9[sizeof (std::pair<int, int>)];

      // parameter_type_list
      char dummy10[sizeof (std::pair<std::vector<std::shared_ptr<quant_c_ast::ArgDeclNode>>, bool>)];

      // abstract_declarator
      char dummy11[sizeof (std::shared_ptr<quant_c_ast::AbstractDeclaratorNode>)];

      // parameter_declaration
      char dummy12[sizeof (std::shared_ptr<quant_c_ast::ArgDeclNode>)];

      // compound_statement
      char dummy13[sizeof (std::shared_ptr<quant_c_ast::BlockNode>)];

      // declaration
      // external_declaration
      char dummy14[sizeof (std::shared_ptr<quant_c_ast::DeclNode>)];

      // declarator
      char dummy15[sizeof (std::shared_ptr<quant_c_ast::DeclaratorNode>)];

      // direct_abstract_declarator
      char dummy16[sizeof (std::shared_ptr<quant_c_ast::DirectAbstractDeclaratorNode>)];

      // direct_declarator
      char dummy17[sizeof (std::shared_ptr<quant_c_ast::DirectDeclaratorNode>)];

      // expression
      // primary_expression
      // postfix_expression
      // unary_expression
      // cast_expression
      // multiplicative_expression
      // additive_expression
      // shift_expression
      // relational_expression
      // quantum_binary_expression
      // equality_expression
      // and_expression
      // exclusive_or_expression
      // inclusive_or_expression
      // logical_and_expression
      // logical_or_expression
      // conditional_expression
      // assignment_expression
      // constant_expression
      // initializer
      char dummy18[sizeof (std::shared_ptr<quant_c_ast::ExprNode>)];

      // function_definition
      char dummy19[sizeof (std::shared_ptr<quant_c_ast::FuncDefNode>)];

      // init_declarator
      char dummy20[sizeof (std::shared_ptr<quant_c_ast::InitDeclaratorNode>)];

      // unary_operator
      char dummy21[sizeof (std::shared_ptr<quant_c_ast::OperatorNode>)];

      // statement
      // labeled_statement
      // expression_statement
      // selection_statement
      // iteration_statement
      // jump_statement
      char dummy22[sizeof (std::shared_ptr<quant_c_ast::StmtNode>)];

      // storage_class_specifier
      char dummy23[sizeof (std::shared_ptr<quant_c_ast::StorageClassSpecNode>)];

      // type_name
      char dummy24[sizeof (std::shared_ptr<quant_c_ast::TypeNameNode>)];

      // type_qualifier
      char dummy25[sizeof (std::shared_ptr<quant_c_ast::TypeQualifierNode>)];

      // type_specifier
      char dummy26[sizeof (std::shared_ptr<quant_c_ast::TypeSpecNode>)];

      // quantum_op_prefix
      char dummy27[sizeof (std::tuple<bool, int, int>)];

      // quantum_unary_op
      char dummy28[sizeof (std::tuple<quant_c_ast::QuantumUnaryOperatorNode::QuantumUnaryOp, int, int>)];

      // parameter_list
      char dummy29[sizeof (std::vector<std::shared_ptr<quant_c_ast::ArgDeclNode>>)];

      // declaration_list
      char dummy30[sizeof (std::vector<std::shared_ptr<quant_c_ast::DeclNode>>)];

      // argument_expression_list
      // initializer_list
      char dummy31[sizeof (std::vector<std::shared_ptr<quant_c_ast::ExprNode>>)];

      // init_declarator_list
      char dummy32[sizeof (std::vector<std::shared_ptr<quant_c_ast::InitDeclaratorNode>>)];

      // pointer
      char dummy33[sizeof (std::vector<std::shared_ptr<quant_c_ast::PointerNode>>)];

      // quantum_op_postfix
      char dummy34[sizeof (std::vector<std::shared_ptr<quant_c_ast::QuantumUnaryPostfixNode>>)];

      // statement_list
      char dummy35[sizeof (std::vector<std::shared_ptr<quant_c_ast::StmtNode>>)];

      // declaration_specifiers
      // specifier_qualifier_list
      char dummy36[sizeof (std::vector<std::shared_ptr<quant_c_ast::TypeNode>>)];

      // type_qualifier_list
      char dummy37[sizeof (std::vector<std::shared_ptr<quant_c_ast::TypeQualifierNode>>)];

      // identifier_list
      char dummy38[sizeof (std::vector<std::shared_ptr<quant_c_token::IdentifierToken>>)];
    };

    /// The size of the largest semantic type.
    enum { size = sizeof (union_type) };

    /// A buffer to store semantic values.
    union
    {
      /// Strongest alignment constraints.
      long double yyalign_me;
      /// A buffer large enough to store any of the semantic values.
      char yyraw[size];
    } yybuffer_;
  };

#else
    typedef YYSTYPE semantic_type;
#endif

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const std::string& m)
        : std::runtime_error (m)
      {}

      syntax_error (const syntax_error& s)
        : std::runtime_error (s.what ())
      {}

      ~syntax_error () YY_NOEXCEPT YY_NOTHROW;
    };

    /// Tokens.
    struct token
    {
      enum yytokentype
      {
        IDENTIFIER = 258,
        INT_LITERAL = 259,
        FLOAT_LITERAL = 260,
        BOOL_LITERAL = 261,
        CHAR_LITERAL = 262,
        STRING_LITERAL = 263,
        TYPE_NAME = 264,
        PTR_OP = 265,
        INC_OP = 266,
        DEC_OP = 267,
        LEFT_OP = 268,
        RIGHT_OP = 269,
        LE_OP = 270,
        GE_OP = 271,
        EQ_OP = 272,
        NE_OP = 273,
        ADD_ASSIGN = 274,
        AND_OP = 275,
        OR_OP = 276,
        MUL_ASSIGN = 277,
        DIV_ASSIGN = 278,
        MOD_ASSIGN = 279,
        SUB_ASSIGN = 280,
        LEFT_ASSIGN = 281,
        RIGHT_ASSIGN = 282,
        AND_ASSIGN = 283,
        XOR_ASSIGN = 284,
        OR_ASSIGN = 285,
        ELLIPSIS = 286,
        TYPEDEF = 287,
        EXTERN = 288,
        STATIC = 289,
        AUTO = 290,
        REGISTER = 291,
        CHAR = 292,
        SHORT = 293,
        INT = 294,
        LONG = 295,
        SIGNED = 296,
        UNSIGNED = 297,
        FLOAT = 298,
        DOUBLE = 299,
        CONST = 300,
        VOLATILE = 301,
        VOID = 302,
        STRUCT = 303,
        UNION = 304,
        ENUM = 305,
        CASE = 306,
        DEFAULT = 307,
        IF = 308,
        ELSE = 309,
        SWITCH = 310,
        WHILE = 311,
        DO = 312,
        FOR = 313,
        GOTO = 314,
        CONTINUE = 315,
        BREAK = 316,
        RETURN = 317,
        SIZEOF = 318,
        BOOL = 319,
        QUANTUM = 320,
        PSWAP = 321,
        ISWAP = 322,
        SWAP = 323,
        X_GATE = 324,
        Y_GATE = 325,
        Z_GATE = 326,
        HADAMARD = 327,
        PHASE = 328,
        S_GATE = 329,
        T_GATE = 330,
        RX = 331,
        RY = 332,
        RZ = 333,
        INVERSE = 334,
        CONTROL = 335,
        MEASURE = 336,
        IDENTITY = 337
      };
    };

    /// (External) token type, as returned by yylex.
    typedef token::yytokentype token_type;

    /// Symbol type: an internal symbol number.
    typedef int symbol_number_type;

    /// The symbol type number to denote an empty symbol.
    enum { empty_symbol = -2 };

    /// Internal symbol number for tokens (subsumed by symbol_number_type).
    typedef signed char token_number_type;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol type
    /// via type_get ().
    ///
    /// Provide access to semantic value.
    template <typename Base>
    struct basic_symbol : Base
    {
      /// Alias to Base.
      typedef Base super_type;

      /// Default constructor.
      basic_symbol ()
        : value ()
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      basic_symbol (basic_symbol&& that);
#endif

      /// Copy constructor.
      basic_symbol (const basic_symbol& that);

      /// Constructor for valueless symbols, and symbols from each type.
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t)
        : Base (t)
      {}
#else
      basic_symbol (typename Base::kind_type t)
        : Base (t)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, int&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const int& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, quant_c_token::BoolLitToken&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const quant_c_token::BoolLitToken& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, quant_c_token::CharLitToken&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const quant_c_token::CharLitToken& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, quant_c_token::FloatLitToken&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const quant_c_token::FloatLitToken& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, quant_c_token::IdentifierToken&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const quant_c_token::IdentifierToken& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, quant_c_token::IntLitToken&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const quant_c_token::IntLitToken& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, quant_c_token::StringLitToken&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const quant_c_token::StringLitToken& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, quant_c_token::TypeNameToken&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const quant_c_token::TypeNameToken& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::pair<int, int>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::pair<int, int>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::pair<std::vector<std::shared_ptr<quant_c_ast::ArgDeclNode>>, bool>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::pair<std::vector<std::shared_ptr<quant_c_ast::ArgDeclNode>>, bool>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::AbstractDeclaratorNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::AbstractDeclaratorNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::ArgDeclNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::ArgDeclNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::BlockNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::BlockNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::DeclNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::DeclNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::DeclaratorNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::DeclaratorNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::DirectAbstractDeclaratorNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::DirectAbstractDeclaratorNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::DirectDeclaratorNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::DirectDeclaratorNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::ExprNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::ExprNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::FuncDefNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::FuncDefNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::InitDeclaratorNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::InitDeclaratorNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::OperatorNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::OperatorNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::StmtNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::StmtNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::StorageClassSpecNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::StorageClassSpecNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::TypeNameNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::TypeNameNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::TypeQualifierNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::TypeQualifierNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<quant_c_ast::TypeSpecNode>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<quant_c_ast::TypeSpecNode>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::tuple<bool, int, int>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::tuple<bool, int, int>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::tuple<quant_c_ast::QuantumUnaryOperatorNode::QuantumUnaryOp, int, int>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::tuple<quant_c_ast::QuantumUnaryOperatorNode::QuantumUnaryOp, int, int>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::vector<std::shared_ptr<quant_c_ast::ArgDeclNode>>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::vector<std::shared_ptr<quant_c_ast::ArgDeclNode>>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::vector<std::shared_ptr<quant_c_ast::DeclNode>>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::vector<std::shared_ptr<quant_c_ast::DeclNode>>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::vector<std::shared_ptr<quant_c_ast::ExprNode>>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::vector<std::shared_ptr<quant_c_ast::ExprNode>>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::vector<std::shared_ptr<quant_c_ast::InitDeclaratorNode>>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::vector<std::shared_ptr<quant_c_ast::InitDeclaratorNode>>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::vector<std::shared_ptr<quant_c_ast::PointerNode>>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::vector<std::shared_ptr<quant_c_ast::PointerNode>>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::vector<std::shared_ptr<quant_c_ast::QuantumUnaryPostfixNode>>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::vector<std::shared_ptr<quant_c_ast::QuantumUnaryPostfixNode>>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::vector<std::shared_ptr<quant_c_ast::StmtNode>>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::vector<std::shared_ptr<quant_c_ast::StmtNode>>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::vector<std::shared_ptr<quant_c_ast::TypeNode>>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::vector<std::shared_ptr<quant_c_ast::TypeNode>>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::vector<std::shared_ptr<quant_c_ast::TypeQualifierNode>>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::vector<std::shared_ptr<quant_c_ast::TypeQualifierNode>>& v)
        : Base (t)
        , value (v)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::vector<std::shared_ptr<quant_c_token::IdentifierToken>>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::vector<std::shared_ptr<quant_c_token::IdentifierToken>>& v)
        : Base (t)
        , value (v)
      {}
#endif

      /// Destroy the symbol.
      ~basic_symbol ()
      {
        clear ();
      }

      /// Destroy contents, and record that is empty.
      void clear ()
      {
        // User destructor.
        symbol_number_type yytype = this->type_get ();
        basic_symbol<Base>& yysym = *this;
        (void) yysym;
        switch (yytype)
        {
       default:
          break;
        }

        // Type destructor.
switch (yytype)
    {
      case 160: // assignment_operator
        value.template destroy< int > ();
        break;

      case 6: // BOOL_LITERAL
        value.template destroy< quant_c_token::BoolLitToken > ();
        break;

      case 7: // CHAR_LITERAL
        value.template destroy< quant_c_token::CharLitToken > ();
        break;

      case 5: // FLOAT_LITERAL
        value.template destroy< quant_c_token::FloatLitToken > ();
        break;

      case 3: // IDENTIFIER
        value.template destroy< quant_c_token::IdentifierToken > ();
        break;

      case 4: // INT_LITERAL
        value.template destroy< quant_c_token::IntLitToken > ();
        break;

      case 8: // STRING_LITERAL
        value.template destroy< quant_c_token::StringLitToken > ();
        break;

      case 9: // TYPE_NAME
        value.template destroy< quant_c_token::TypeNameToken > ();
        break;

      case 10: // PTR_OP
      case 11: // INC_OP
      case 12: // DEC_OP
      case 13: // LEFT_OP
      case 14: // RIGHT_OP
      case 15: // LE_OP
      case 16: // GE_OP
      case 17: // EQ_OP
      case 18: // NE_OP
      case 19: // ADD_ASSIGN
      case 20: // AND_OP
      case 21: // OR_OP
      case 22: // MUL_ASSIGN
      case 23: // DIV_ASSIGN
      case 24: // MOD_ASSIGN
      case 25: // SUB_ASSIGN
      case 26: // LEFT_ASSIGN
      case 27: // RIGHT_ASSIGN
      case 28: // AND_ASSIGN
      case 29: // XOR_ASSIGN
      case 30: // OR_ASSIGN
      case 31: // ELLIPSIS
      case 32: // ';'
      case 33: // '{'
      case 34: // '}'
      case 35: // ','
      case 36: // ':'
      case 37: // '='
      case 38: // '('
      case 39: // ')'
      case 40: // '['
      case 41: // ']'
      case 42: // '.'
      case 43: // '&'
      case 44: // '!'
      case 45: // '~'
      case 46: // '-'
      case 47: // '+'
      case 48: // '*'
      case 49: // '/'
      case 50: // '%'
      case 51: // '<'
      case 52: // '>'
      case 53: // '^'
      case 54: // '|'
      case 55: // '?'
      case 56: // TYPEDEF
      case 57: // EXTERN
      case 58: // STATIC
      case 59: // AUTO
      case 60: // REGISTER
      case 61: // CHAR
      case 62: // SHORT
      case 63: // INT
      case 64: // LONG
      case 65: // SIGNED
      case 66: // UNSIGNED
      case 67: // FLOAT
      case 68: // DOUBLE
      case 69: // CONST
      case 70: // VOLATILE
      case 71: // VOID
      case 72: // STRUCT
      case 73: // UNION
      case 74: // ENUM
      case 75: // CASE
      case 76: // DEFAULT
      case 77: // IF
      case 78: // ELSE
      case 79: // SWITCH
      case 80: // WHILE
      case 81: // DO
      case 82: // FOR
      case 83: // GOTO
      case 84: // CONTINUE
      case 85: // BREAK
      case 86: // RETURN
      case 87: // SIZEOF
      case 88: // BOOL
      case 89: // QUANTUM
      case 90: // PSWAP
      case 91: // ISWAP
      case 92: // SWAP
      case 93: // X_GATE
      case 94: // Y_GATE
      case 95: // Z_GATE
      case 96: // HADAMARD
      case 97: // PHASE
      case 98: // S_GATE
      case 99: // T_GATE
      case 100: // RX
      case 101: // RY
      case 102: // RZ
      case 103: // INVERSE
      case 104: // CONTROL
      case 105: // MEASURE
      case 106: // IDENTITY
        value.template destroy< std::pair<int, int> > ();
        break;

      case 138: // parameter_type_list
        value.template destroy< std::pair<std::vector<std::shared_ptr<quant_c_ast::ArgDeclNode>>, bool> > ();
        break;

      case 144: // abstract_declarator
        value.template destroy< std::shared_ptr<quant_c_ast::AbstractDeclaratorNode> > ();
        break;

      case 134: // parameter_declaration
        value.template destroy< std::shared_ptr<quant_c_ast::ArgDeclNode> > ();
        break;

      case 152: // compound_statement
        value.template destroy< std::shared_ptr<quant_c_ast::BlockNode> > ();
        break;

      case 130: // declaration
      case 135: // external_declaration
        value.template destroy< std::shared_ptr<quant_c_ast::DeclNode> > ();
        break;

      case 131: // declarator
        value.template destroy< std::shared_ptr<quant_c_ast::DeclaratorNode> > ();
        break;

      case 145: // direct_abstract_declarator
        value.template destroy< std::shared_ptr<quant_c_ast::DirectAbstractDeclaratorNode> > ();
        break;

      case 132: // direct_declarator
        value.template destroy< std::shared_ptr<quant_c_ast::DirectDeclaratorNode> > ();
        break;

      case 108: // expression
      case 109: // primary_expression
      case 110: // postfix_expression
      case 111: // unary_expression
      case 112: // cast_expression
      case 113: // multiplicative_expression
      case 114: // additive_expression
      case 115: // shift_expression
      case 116: // relational_expression
      case 117: // quantum_binary_expression
      case 118: // equality_expression
      case 119: // and_expression
      case 120: // exclusive_or_expression
      case 121: // inclusive_or_expression
      case 122: // logical_and_expression
      case 123: // logical_or_expression
      case 124: // conditional_expression
      case 125: // assignment_expression
      case 126: // constant_expression
      case 127: // initializer
        value.template destroy< std::shared_ptr<quant_c_ast::ExprNode> > ();
        break;

      case 158: // function_definition
        value.template destroy< std::shared_ptr<quant_c_ast::FuncDefNode> > ();
        break;

      case 133: // init_declarator
        value.template destroy< std::shared_ptr<quant_c_ast::InitDeclaratorNode> > ();
        break;

      case 159: // unary_operator
        value.template destroy< std::shared_ptr<quant_c_ast::OperatorNode> > ();
        break;

      case 150: // statement
      case 151: // labeled_statement
      case 153: // expression_statement
      case 154: // selection_statement
      case 155: // iteration_statement
      case 156: // jump_statement
        value.template destroy< std::shared_ptr<quant_c_ast::StmtNode> > ();
        break;

      case 142: // storage_class_specifier
        value.template destroy< std::shared_ptr<quant_c_ast::StorageClassSpecNode> > ();
        break;

      case 143: // type_name
        value.template destroy< std::shared_ptr<quant_c_ast::TypeNameNode> > ();
        break;

      case 141: // type_qualifier
        value.template destroy< std::shared_ptr<quant_c_ast::TypeQualifierNode> > ();
        break;

      case 140: // type_specifier
        value.template destroy< std::shared_ptr<quant_c_ast::TypeSpecNode> > ();
        break;

      case 162: // quantum_op_prefix
        value.template destroy< std::tuple<bool, int, int> > ();
        break;

      case 161: // quantum_unary_op
        value.template destroy< std::tuple<quant_c_ast::QuantumUnaryOperatorNode::QuantumUnaryOp, int, int> > ();
        break;

      case 139: // parameter_list
        value.template destroy< std::vector<std::shared_ptr<quant_c_ast::ArgDeclNode>> > ();
        break;

      case 137: // declaration_list
        value.template destroy< std::vector<std::shared_ptr<quant_c_ast::DeclNode>> > ();
        break;

      case 128: // argument_expression_list
      case 129: // initializer_list
        value.template destroy< std::vector<std::shared_ptr<quant_c_ast::ExprNode>> > ();
        break;

      case 136: // init_declarator_list
        value.template destroy< std::vector<std::shared_ptr<quant_c_ast::InitDeclaratorNode>> > ();
        break;

      case 147: // pointer
        value.template destroy< std::vector<std::shared_ptr<quant_c_ast::PointerNode>> > ();
        break;

      case 163: // quantum_op_postfix
        value.template destroy< std::vector<std::shared_ptr<quant_c_ast::QuantumUnaryPostfixNode>> > ();
        break;

      case 157: // statement_list
        value.template destroy< std::vector<std::shared_ptr<quant_c_ast::StmtNode>> > ();
        break;

      case 146: // declaration_specifiers
      case 148: // specifier_qualifier_list
        value.template destroy< std::vector<std::shared_ptr<quant_c_ast::TypeNode>> > ();
        break;

      case 149: // type_qualifier_list
        value.template destroy< std::vector<std::shared_ptr<quant_c_ast::TypeQualifierNode>> > ();
        break;

      case 164: // identifier_list
        value.template destroy< std::vector<std::shared_ptr<quant_c_token::IdentifierToken>> > ();
        break;

      default:
        break;
    }

        Base::clear ();
      }

      /// Whether empty.
      bool empty () const YY_NOEXCEPT;

      /// Destructive move, \a s is emptied into this.
      void move (basic_symbol& s);

      /// The semantic value.
      semantic_type value;

    private:
#if YY_CPLUSPLUS < 201103L
      /// Assignment operator.
      basic_symbol& operator= (const basic_symbol& that);
#endif
    };

    /// Type access provider for token (enum) based symbols.
    struct by_type
    {
      /// Default constructor.
      by_type ();

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      by_type (by_type&& that);
#endif

      /// Copy constructor.
      by_type (const by_type& that);

      /// The symbol type as needed by the constructor.
      typedef token_type kind_type;

      /// Constructor from (external) token numbers.
      by_type (kind_type t);

      /// Record that this symbol is empty.
      void clear ();

      /// Steal the symbol type from \a that.
      void move (by_type& that);

      /// The (internal) type number (corresponding to \a type).
      /// \a empty when empty.
      symbol_number_type type_get () const YY_NOEXCEPT;

      /// The symbol type.
      /// \a empty_symbol when empty.
      /// An int, not token_number_type, to be able to store empty_symbol.
      int type;
    };

    /// "External" symbols: returned by the scanner.
    struct symbol_type : basic_symbol<by_type>
    {
      /// Superclass.
      typedef basic_symbol<by_type> super_type;

      /// Empty symbol.
      symbol_type () {}

      /// Constructor for valueless symbols, and symbols from each type.
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok)
        : super_type(token_type (tok))
      {
        YY_ASSERT (tok == 0);
      }
#else
      symbol_type (int tok)
        : super_type(token_type (tok))
      {
        YY_ASSERT (tok == 0);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, quant_c_token::BoolLitToken v)
        : super_type(token_type (tok), std::move (v))
      {
        YY_ASSERT (tok == token::BOOL_LITERAL);
      }
#else
      symbol_type (int tok, const quant_c_token::BoolLitToken& v)
        : super_type(token_type (tok), v)
      {
        YY_ASSERT (tok == token::BOOL_LITERAL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, quant_c_token::CharLitToken v)
        : super_type(token_type (tok), std::move (v))
      {
        YY_ASSERT (tok == token::CHAR_LITERAL);
      }
#else
      symbol_type (int tok, const quant_c_token::CharLitToken& v)
        : super_type(token_type (tok), v)
      {
        YY_ASSERT (tok == token::CHAR_LITERAL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, quant_c_token::FloatLitToken v)
        : super_type(token_type (tok), std::move (v))
      {
        YY_ASSERT (tok == token::FLOAT_LITERAL);
      }
#else
      symbol_type (int tok, const quant_c_token::FloatLitToken& v)
        : super_type(token_type (tok), v)
      {
        YY_ASSERT (tok == token::FLOAT_LITERAL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, quant_c_token::IdentifierToken v)
        : super_type(token_type (tok), std::move (v))
      {
        YY_ASSERT (tok == token::IDENTIFIER);
      }
#else
      symbol_type (int tok, const quant_c_token::IdentifierToken& v)
        : super_type(token_type (tok), v)
      {
        YY_ASSERT (tok == token::IDENTIFIER);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, quant_c_token::IntLitToken v)
        : super_type(token_type (tok), std::move (v))
      {
        YY_ASSERT (tok == token::INT_LITERAL);
      }
#else
      symbol_type (int tok, const quant_c_token::IntLitToken& v)
        : super_type(token_type (tok), v)
      {
        YY_ASSERT (tok == token::INT_LITERAL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, quant_c_token::StringLitToken v)
        : super_type(token_type (tok), std::move (v))
      {
        YY_ASSERT (tok == token::STRING_LITERAL);
      }
#else
      symbol_type (int tok, const quant_c_token::StringLitToken& v)
        : super_type(token_type (tok), v)
      {
        YY_ASSERT (tok == token::STRING_LITERAL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, quant_c_token::TypeNameToken v)
        : super_type(token_type (tok), std::move (v))
      {
        YY_ASSERT (tok == token::TYPE_NAME);
      }
#else
      symbol_type (int tok, const quant_c_token::TypeNameToken& v)
        : super_type(token_type (tok), v)
      {
        YY_ASSERT (tok == token::TYPE_NAME);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, std::pair<int, int> v)
        : super_type(token_type (tok), std::move (v))
      {
        YY_ASSERT (tok == token::PTR_OP || tok == token::INC_OP || tok == token::DEC_OP || tok == token::LEFT_OP || tok == token::RIGHT_OP || tok == token::LE_OP || tok == token::GE_OP || tok == token::EQ_OP || tok == token::NE_OP || tok == token::ADD_ASSIGN || tok == token::AND_OP || tok == token::OR_OP || tok == token::MUL_ASSIGN || tok == token::DIV_ASSIGN || tok == token::MOD_ASSIGN || tok == token::SUB_ASSIGN || tok == token::LEFT_ASSIGN || tok == token::RIGHT_ASSIGN || tok == token::AND_ASSIGN || tok == token::XOR_ASSIGN || tok == token::OR_ASSIGN || tok == token::ELLIPSIS || tok == 59 || tok == 123 || tok == 125 || tok == 44 || tok == 58 || tok == 61 || tok == 40 || tok == 41 || tok == 91 || tok == 93 || tok == 46 || tok == 38 || tok == 33 || tok == 126 || tok == 45 || tok == 43 || tok == 42 || tok == 47 || tok == 37 || tok == 60 || tok == 62 || tok == 94 || tok == 124 || tok == 63 || tok == token::TYPEDEF || tok == token::EXTERN || tok == token::STATIC || tok == token::AUTO || tok == token::REGISTER || tok == token::CHAR || tok == token::SHORT || tok == token::INT || tok == token::LONG || tok == token::SIGNED || tok == token::UNSIGNED || tok == token::FLOAT || tok == token::DOUBLE || tok == token::CONST || tok == token::VOLATILE || tok == token::VOID || tok == token::STRUCT || tok == token::UNION || tok == token::ENUM || tok == token::CASE || tok == token::DEFAULT || tok == token::IF || tok == token::ELSE || tok == token::SWITCH || tok == token::WHILE || tok == token::DO || tok == token::FOR || tok == token::GOTO || tok == token::CONTINUE || tok == token::BREAK || tok == token::RETURN || tok == token::SIZEOF || tok == token::BOOL || tok == token::QUANTUM || tok == token::PSWAP || tok == token::ISWAP || tok == token::SWAP || tok == token::X_GATE || tok == token::Y_GATE || tok == token::Z_GATE || tok == token::HADAMARD || tok == token::PHASE || tok == token::S_GATE || tok == token::T_GATE || tok == token::RX || tok == token::RY || tok == token::RZ || tok == token::INVERSE || tok == token::CONTROL || tok == token::MEASURE || tok == token::IDENTITY);
      }
#else
      symbol_type (int tok, const std::pair<int, int>& v)
        : super_type(token_type (tok), v)
      {
        YY_ASSERT (tok == token::PTR_OP || tok == token::INC_OP || tok == token::DEC_OP || tok == token::LEFT_OP || tok == token::RIGHT_OP || tok == token::LE_OP || tok == token::GE_OP || tok == token::EQ_OP || tok == token::NE_OP || tok == token::ADD_ASSIGN || tok == token::AND_OP || tok == token::OR_OP || tok == token::MUL_ASSIGN || tok == token::DIV_ASSIGN || tok == token::MOD_ASSIGN || tok == token::SUB_ASSIGN || tok == token::LEFT_ASSIGN || tok == token::RIGHT_ASSIGN || tok == token::AND_ASSIGN || tok == token::XOR_ASSIGN || tok == token::OR_ASSIGN || tok == token::ELLIPSIS || tok == 59 || tok == 123 || tok == 125 || tok == 44 || tok == 58 || tok == 61 || tok == 40 || tok == 41 || tok == 91 || tok == 93 || tok == 46 || tok == 38 || tok == 33 || tok == 126 || tok == 45 || tok == 43 || tok == 42 || tok == 47 || tok == 37 || tok == 60 || tok == 62 || tok == 94 || tok == 124 || tok == 63 || tok == token::TYPEDEF || tok == token::EXTERN || tok == token::STATIC || tok == token::AUTO || tok == token::REGISTER || tok == token::CHAR || tok == token::SHORT || tok == token::INT || tok == token::LONG || tok == token::SIGNED || tok == token::UNSIGNED || tok == token::FLOAT || tok == token::DOUBLE || tok == token::CONST || tok == token::VOLATILE || tok == token::VOID || tok == token::STRUCT || tok == token::UNION || tok == token::ENUM || tok == token::CASE || tok == token::DEFAULT || tok == token::IF || tok == token::ELSE || tok == token::SWITCH || tok == token::WHILE || tok == token::DO || tok == token::FOR || tok == token::GOTO || tok == token::CONTINUE || tok == token::BREAK || tok == token::RETURN || tok == token::SIZEOF || tok == token::BOOL || tok == token::QUANTUM || tok == token::PSWAP || tok == token::ISWAP || tok == token::SWAP || tok == token::X_GATE || tok == token::Y_GATE || tok == token::Z_GATE || tok == token::HADAMARD || tok == token::PHASE || tok == token::S_GATE || tok == token::T_GATE || tok == token::RX || tok == token::RY || tok == token::RZ || tok == token::INVERSE || tok == token::CONTROL || tok == token::MEASURE || tok == token::IDENTITY);
      }
#endif
    };

    /// Build a parser object.
    Parser (Scanner& scanner_yyarg, quant_c_ast::TranslationUnitNode& prog_yyarg);
    virtual ~Parser ();

    /// Parse.  An alias for parse ().
    /// \returns  0 iff parsing succeeded.
    int operator() ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

#if YYDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

    /// Report a syntax error.
    /// \param msg    a description of the syntax error.
    virtual void error (const std::string& msg);

    /// Report a syntax error.
    void error (const syntax_error& err);

    // Implementation of make_symbol for each symbol type.
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_IDENTIFIER (quant_c_token::IdentifierToken v)
      {
        return symbol_type (token::IDENTIFIER, std::move (v));
      }
#else
      static
      symbol_type
      make_IDENTIFIER (const quant_c_token::IdentifierToken& v)
      {
        return symbol_type (token::IDENTIFIER, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INT_LITERAL (quant_c_token::IntLitToken v)
      {
        return symbol_type (token::INT_LITERAL, std::move (v));
      }
#else
      static
      symbol_type
      make_INT_LITERAL (const quant_c_token::IntLitToken& v)
      {
        return symbol_type (token::INT_LITERAL, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FLOAT_LITERAL (quant_c_token::FloatLitToken v)
      {
        return symbol_type (token::FLOAT_LITERAL, std::move (v));
      }
#else
      static
      symbol_type
      make_FLOAT_LITERAL (const quant_c_token::FloatLitToken& v)
      {
        return symbol_type (token::FLOAT_LITERAL, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BOOL_LITERAL (quant_c_token::BoolLitToken v)
      {
        return symbol_type (token::BOOL_LITERAL, std::move (v));
      }
#else
      static
      symbol_type
      make_BOOL_LITERAL (const quant_c_token::BoolLitToken& v)
      {
        return symbol_type (token::BOOL_LITERAL, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CHAR_LITERAL (quant_c_token::CharLitToken v)
      {
        return symbol_type (token::CHAR_LITERAL, std::move (v));
      }
#else
      static
      symbol_type
      make_CHAR_LITERAL (const quant_c_token::CharLitToken& v)
      {
        return symbol_type (token::CHAR_LITERAL, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STRING_LITERAL (quant_c_token::StringLitToken v)
      {
        return symbol_type (token::STRING_LITERAL, std::move (v));
      }
#else
      static
      symbol_type
      make_STRING_LITERAL (const quant_c_token::StringLitToken& v)
      {
        return symbol_type (token::STRING_LITERAL, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TYPE_NAME (quant_c_token::TypeNameToken v)
      {
        return symbol_type (token::TYPE_NAME, std::move (v));
      }
#else
      static
      symbol_type
      make_TYPE_NAME (const quant_c_token::TypeNameToken& v)
      {
        return symbol_type (token::TYPE_NAME, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PTR_OP (std::pair<int, int> v)
      {
        return symbol_type (token::PTR_OP, std::move (v));
      }
#else
      static
      symbol_type
      make_PTR_OP (const std::pair<int, int>& v)
      {
        return symbol_type (token::PTR_OP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INC_OP (std::pair<int, int> v)
      {
        return symbol_type (token::INC_OP, std::move (v));
      }
#else
      static
      symbol_type
      make_INC_OP (const std::pair<int, int>& v)
      {
        return symbol_type (token::INC_OP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DEC_OP (std::pair<int, int> v)
      {
        return symbol_type (token::DEC_OP, std::move (v));
      }
#else
      static
      symbol_type
      make_DEC_OP (const std::pair<int, int>& v)
      {
        return symbol_type (token::DEC_OP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LEFT_OP (std::pair<int, int> v)
      {
        return symbol_type (token::LEFT_OP, std::move (v));
      }
#else
      static
      symbol_type
      make_LEFT_OP (const std::pair<int, int>& v)
      {
        return symbol_type (token::LEFT_OP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RIGHT_OP (std::pair<int, int> v)
      {
        return symbol_type (token::RIGHT_OP, std::move (v));
      }
#else
      static
      symbol_type
      make_RIGHT_OP (const std::pair<int, int>& v)
      {
        return symbol_type (token::RIGHT_OP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LE_OP (std::pair<int, int> v)
      {
        return symbol_type (token::LE_OP, std::move (v));
      }
#else
      static
      symbol_type
      make_LE_OP (const std::pair<int, int>& v)
      {
        return symbol_type (token::LE_OP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_GE_OP (std::pair<int, int> v)
      {
        return symbol_type (token::GE_OP, std::move (v));
      }
#else
      static
      symbol_type
      make_GE_OP (const std::pair<int, int>& v)
      {
        return symbol_type (token::GE_OP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EQ_OP (std::pair<int, int> v)
      {
        return symbol_type (token::EQ_OP, std::move (v));
      }
#else
      static
      symbol_type
      make_EQ_OP (const std::pair<int, int>& v)
      {
        return symbol_type (token::EQ_OP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NE_OP (std::pair<int, int> v)
      {
        return symbol_type (token::NE_OP, std::move (v));
      }
#else
      static
      symbol_type
      make_NE_OP (const std::pair<int, int>& v)
      {
        return symbol_type (token::NE_OP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ADD_ASSIGN (std::pair<int, int> v)
      {
        return symbol_type (token::ADD_ASSIGN, std::move (v));
      }
#else
      static
      symbol_type
      make_ADD_ASSIGN (const std::pair<int, int>& v)
      {
        return symbol_type (token::ADD_ASSIGN, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_AND_OP (std::pair<int, int> v)
      {
        return symbol_type (token::AND_OP, std::move (v));
      }
#else
      static
      symbol_type
      make_AND_OP (const std::pair<int, int>& v)
      {
        return symbol_type (token::AND_OP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OR_OP (std::pair<int, int> v)
      {
        return symbol_type (token::OR_OP, std::move (v));
      }
#else
      static
      symbol_type
      make_OR_OP (const std::pair<int, int>& v)
      {
        return symbol_type (token::OR_OP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MUL_ASSIGN (std::pair<int, int> v)
      {
        return symbol_type (token::MUL_ASSIGN, std::move (v));
      }
#else
      static
      symbol_type
      make_MUL_ASSIGN (const std::pair<int, int>& v)
      {
        return symbol_type (token::MUL_ASSIGN, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DIV_ASSIGN (std::pair<int, int> v)
      {
        return symbol_type (token::DIV_ASSIGN, std::move (v));
      }
#else
      static
      symbol_type
      make_DIV_ASSIGN (const std::pair<int, int>& v)
      {
        return symbol_type (token::DIV_ASSIGN, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MOD_ASSIGN (std::pair<int, int> v)
      {
        return symbol_type (token::MOD_ASSIGN, std::move (v));
      }
#else
      static
      symbol_type
      make_MOD_ASSIGN (const std::pair<int, int>& v)
      {
        return symbol_type (token::MOD_ASSIGN, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SUB_ASSIGN (std::pair<int, int> v)
      {
        return symbol_type (token::SUB_ASSIGN, std::move (v));
      }
#else
      static
      symbol_type
      make_SUB_ASSIGN (const std::pair<int, int>& v)
      {
        return symbol_type (token::SUB_ASSIGN, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LEFT_ASSIGN (std::pair<int, int> v)
      {
        return symbol_type (token::LEFT_ASSIGN, std::move (v));
      }
#else
      static
      symbol_type
      make_LEFT_ASSIGN (const std::pair<int, int>& v)
      {
        return symbol_type (token::LEFT_ASSIGN, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RIGHT_ASSIGN (std::pair<int, int> v)
      {
        return symbol_type (token::RIGHT_ASSIGN, std::move (v));
      }
#else
      static
      symbol_type
      make_RIGHT_ASSIGN (const std::pair<int, int>& v)
      {
        return symbol_type (token::RIGHT_ASSIGN, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_AND_ASSIGN (std::pair<int, int> v)
      {
        return symbol_type (token::AND_ASSIGN, std::move (v));
      }
#else
      static
      symbol_type
      make_AND_ASSIGN (const std::pair<int, int>& v)
      {
        return symbol_type (token::AND_ASSIGN, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_XOR_ASSIGN (std::pair<int, int> v)
      {
        return symbol_type (token::XOR_ASSIGN, std::move (v));
      }
#else
      static
      symbol_type
      make_XOR_ASSIGN (const std::pair<int, int>& v)
      {
        return symbol_type (token::XOR_ASSIGN, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OR_ASSIGN (std::pair<int, int> v)
      {
        return symbol_type (token::OR_ASSIGN, std::move (v));
      }
#else
      static
      symbol_type
      make_OR_ASSIGN (const std::pair<int, int>& v)
      {
        return symbol_type (token::OR_ASSIGN, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ELLIPSIS (std::pair<int, int> v)
      {
        return symbol_type (token::ELLIPSIS, std::move (v));
      }
#else
      static
      symbol_type
      make_ELLIPSIS (const std::pair<int, int>& v)
      {
        return symbol_type (token::ELLIPSIS, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TYPEDEF (std::pair<int, int> v)
      {
        return symbol_type (token::TYPEDEF, std::move (v));
      }
#else
      static
      symbol_type
      make_TYPEDEF (const std::pair<int, int>& v)
      {
        return symbol_type (token::TYPEDEF, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EXTERN (std::pair<int, int> v)
      {
        return symbol_type (token::EXTERN, std::move (v));
      }
#else
      static
      symbol_type
      make_EXTERN (const std::pair<int, int>& v)
      {
        return symbol_type (token::EXTERN, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STATIC (std::pair<int, int> v)
      {
        return symbol_type (token::STATIC, std::move (v));
      }
#else
      static
      symbol_type
      make_STATIC (const std::pair<int, int>& v)
      {
        return symbol_type (token::STATIC, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_AUTO (std::pair<int, int> v)
      {
        return symbol_type (token::AUTO, std::move (v));
      }
#else
      static
      symbol_type
      make_AUTO (const std::pair<int, int>& v)
      {
        return symbol_type (token::AUTO, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_REGISTER (std::pair<int, int> v)
      {
        return symbol_type (token::REGISTER, std::move (v));
      }
#else
      static
      symbol_type
      make_REGISTER (const std::pair<int, int>& v)
      {
        return symbol_type (token::REGISTER, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CHAR (std::pair<int, int> v)
      {
        return symbol_type (token::CHAR, std::move (v));
      }
#else
      static
      symbol_type
      make_CHAR (const std::pair<int, int>& v)
      {
        return symbol_type (token::CHAR, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SHORT (std::pair<int, int> v)
      {
        return symbol_type (token::SHORT, std::move (v));
      }
#else
      static
      symbol_type
      make_SHORT (const std::pair<int, int>& v)
      {
        return symbol_type (token::SHORT, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INT (std::pair<int, int> v)
      {
        return symbol_type (token::INT, std::move (v));
      }
#else
      static
      symbol_type
      make_INT (const std::pair<int, int>& v)
      {
        return symbol_type (token::INT, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LONG (std::pair<int, int> v)
      {
        return symbol_type (token::LONG, std::move (v));
      }
#else
      static
      symbol_type
      make_LONG (const std::pair<int, int>& v)
      {
        return symbol_type (token::LONG, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SIGNED (std::pair<int, int> v)
      {
        return symbol_type (token::SIGNED, std::move (v));
      }
#else
      static
      symbol_type
      make_SIGNED (const std::pair<int, int>& v)
      {
        return symbol_type (token::SIGNED, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UNSIGNED (std::pair<int, int> v)
      {
        return symbol_type (token::UNSIGNED, std::move (v));
      }
#else
      static
      symbol_type
      make_UNSIGNED (const std::pair<int, int>& v)
      {
        return symbol_type (token::UNSIGNED, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FLOAT (std::pair<int, int> v)
      {
        return symbol_type (token::FLOAT, std::move (v));
      }
#else
      static
      symbol_type
      make_FLOAT (const std::pair<int, int>& v)
      {
        return symbol_type (token::FLOAT, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DOUBLE (std::pair<int, int> v)
      {
        return symbol_type (token::DOUBLE, std::move (v));
      }
#else
      static
      symbol_type
      make_DOUBLE (const std::pair<int, int>& v)
      {
        return symbol_type (token::DOUBLE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CONST (std::pair<int, int> v)
      {
        return symbol_type (token::CONST, std::move (v));
      }
#else
      static
      symbol_type
      make_CONST (const std::pair<int, int>& v)
      {
        return symbol_type (token::CONST, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_VOLATILE (std::pair<int, int> v)
      {
        return symbol_type (token::VOLATILE, std::move (v));
      }
#else
      static
      symbol_type
      make_VOLATILE (const std::pair<int, int>& v)
      {
        return symbol_type (token::VOLATILE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_VOID (std::pair<int, int> v)
      {
        return symbol_type (token::VOID, std::move (v));
      }
#else
      static
      symbol_type
      make_VOID (const std::pair<int, int>& v)
      {
        return symbol_type (token::VOID, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STRUCT (std::pair<int, int> v)
      {
        return symbol_type (token::STRUCT, std::move (v));
      }
#else
      static
      symbol_type
      make_STRUCT (const std::pair<int, int>& v)
      {
        return symbol_type (token::STRUCT, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UNION (std::pair<int, int> v)
      {
        return symbol_type (token::UNION, std::move (v));
      }
#else
      static
      symbol_type
      make_UNION (const std::pair<int, int>& v)
      {
        return symbol_type (token::UNION, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ENUM (std::pair<int, int> v)
      {
        return symbol_type (token::ENUM, std::move (v));
      }
#else
      static
      symbol_type
      make_ENUM (const std::pair<int, int>& v)
      {
        return symbol_type (token::ENUM, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CASE (std::pair<int, int> v)
      {
        return symbol_type (token::CASE, std::move (v));
      }
#else
      static
      symbol_type
      make_CASE (const std::pair<int, int>& v)
      {
        return symbol_type (token::CASE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DEFAULT (std::pair<int, int> v)
      {
        return symbol_type (token::DEFAULT, std::move (v));
      }
#else
      static
      symbol_type
      make_DEFAULT (const std::pair<int, int>& v)
      {
        return symbol_type (token::DEFAULT, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_IF (std::pair<int, int> v)
      {
        return symbol_type (token::IF, std::move (v));
      }
#else
      static
      symbol_type
      make_IF (const std::pair<int, int>& v)
      {
        return symbol_type (token::IF, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ELSE (std::pair<int, int> v)
      {
        return symbol_type (token::ELSE, std::move (v));
      }
#else
      static
      symbol_type
      make_ELSE (const std::pair<int, int>& v)
      {
        return symbol_type (token::ELSE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SWITCH (std::pair<int, int> v)
      {
        return symbol_type (token::SWITCH, std::move (v));
      }
#else
      static
      symbol_type
      make_SWITCH (const std::pair<int, int>& v)
      {
        return symbol_type (token::SWITCH, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_WHILE (std::pair<int, int> v)
      {
        return symbol_type (token::WHILE, std::move (v));
      }
#else
      static
      symbol_type
      make_WHILE (const std::pair<int, int>& v)
      {
        return symbol_type (token::WHILE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DO (std::pair<int, int> v)
      {
        return symbol_type (token::DO, std::move (v));
      }
#else
      static
      symbol_type
      make_DO (const std::pair<int, int>& v)
      {
        return symbol_type (token::DO, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FOR (std::pair<int, int> v)
      {
        return symbol_type (token::FOR, std::move (v));
      }
#else
      static
      symbol_type
      make_FOR (const std::pair<int, int>& v)
      {
        return symbol_type (token::FOR, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_GOTO (std::pair<int, int> v)
      {
        return symbol_type (token::GOTO, std::move (v));
      }
#else
      static
      symbol_type
      make_GOTO (const std::pair<int, int>& v)
      {
        return symbol_type (token::GOTO, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CONTINUE (std::pair<int, int> v)
      {
        return symbol_type (token::CONTINUE, std::move (v));
      }
#else
      static
      symbol_type
      make_CONTINUE (const std::pair<int, int>& v)
      {
        return symbol_type (token::CONTINUE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BREAK (std::pair<int, int> v)
      {
        return symbol_type (token::BREAK, std::move (v));
      }
#else
      static
      symbol_type
      make_BREAK (const std::pair<int, int>& v)
      {
        return symbol_type (token::BREAK, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RETURN (std::pair<int, int> v)
      {
        return symbol_type (token::RETURN, std::move (v));
      }
#else
      static
      symbol_type
      make_RETURN (const std::pair<int, int>& v)
      {
        return symbol_type (token::RETURN, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SIZEOF (std::pair<int, int> v)
      {
        return symbol_type (token::SIZEOF, std::move (v));
      }
#else
      static
      symbol_type
      make_SIZEOF (const std::pair<int, int>& v)
      {
        return symbol_type (token::SIZEOF, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BOOL (std::pair<int, int> v)
      {
        return symbol_type (token::BOOL, std::move (v));
      }
#else
      static
      symbol_type
      make_BOOL (const std::pair<int, int>& v)
      {
        return symbol_type (token::BOOL, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_QUANTUM (std::pair<int, int> v)
      {
        return symbol_type (token::QUANTUM, std::move (v));
      }
#else
      static
      symbol_type
      make_QUANTUM (const std::pair<int, int>& v)
      {
        return symbol_type (token::QUANTUM, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PSWAP (std::pair<int, int> v)
      {
        return symbol_type (token::PSWAP, std::move (v));
      }
#else
      static
      symbol_type
      make_PSWAP (const std::pair<int, int>& v)
      {
        return symbol_type (token::PSWAP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ISWAP (std::pair<int, int> v)
      {
        return symbol_type (token::ISWAP, std::move (v));
      }
#else
      static
      symbol_type
      make_ISWAP (const std::pair<int, int>& v)
      {
        return symbol_type (token::ISWAP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SWAP (std::pair<int, int> v)
      {
        return symbol_type (token::SWAP, std::move (v));
      }
#else
      static
      symbol_type
      make_SWAP (const std::pair<int, int>& v)
      {
        return symbol_type (token::SWAP, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_X_GATE (std::pair<int, int> v)
      {
        return symbol_type (token::X_GATE, std::move (v));
      }
#else
      static
      symbol_type
      make_X_GATE (const std::pair<int, int>& v)
      {
        return symbol_type (token::X_GATE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Y_GATE (std::pair<int, int> v)
      {
        return symbol_type (token::Y_GATE, std::move (v));
      }
#else
      static
      symbol_type
      make_Y_GATE (const std::pair<int, int>& v)
      {
        return symbol_type (token::Y_GATE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z_GATE (std::pair<int, int> v)
      {
        return symbol_type (token::Z_GATE, std::move (v));
      }
#else
      static
      symbol_type
      make_Z_GATE (const std::pair<int, int>& v)
      {
        return symbol_type (token::Z_GATE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_HADAMARD (std::pair<int, int> v)
      {
        return symbol_type (token::HADAMARD, std::move (v));
      }
#else
      static
      symbol_type
      make_HADAMARD (const std::pair<int, int>& v)
      {
        return symbol_type (token::HADAMARD, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PHASE (std::pair<int, int> v)
      {
        return symbol_type (token::PHASE, std::move (v));
      }
#else
      static
      symbol_type
      make_PHASE (const std::pair<int, int>& v)
      {
        return symbol_type (token::PHASE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_S_GATE (std::pair<int, int> v)
      {
        return symbol_type (token::S_GATE, std::move (v));
      }
#else
      static
      symbol_type
      make_S_GATE (const std::pair<int, int>& v)
      {
        return symbol_type (token::S_GATE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_T_GATE (std::pair<int, int> v)
      {
        return symbol_type (token::T_GATE, std::move (v));
      }
#else
      static
      symbol_type
      make_T_GATE (const std::pair<int, int>& v)
      {
        return symbol_type (token::T_GATE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RX (std::pair<int, int> v)
      {
        return symbol_type (token::RX, std::move (v));
      }
#else
      static
      symbol_type
      make_RX (const std::pair<int, int>& v)
      {
        return symbol_type (token::RX, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RY (std::pair<int, int> v)
      {
        return symbol_type (token::RY, std::move (v));
      }
#else
      static
      symbol_type
      make_RY (const std::pair<int, int>& v)
      {
        return symbol_type (token::RY, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RZ (std::pair<int, int> v)
      {
        return symbol_type (token::RZ, std::move (v));
      }
#else
      static
      symbol_type
      make_RZ (const std::pair<int, int>& v)
      {
        return symbol_type (token::RZ, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INVERSE (std::pair<int, int> v)
      {
        return symbol_type (token::INVERSE, std::move (v));
      }
#else
      static
      symbol_type
      make_INVERSE (const std::pair<int, int>& v)
      {
        return symbol_type (token::INVERSE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CONTROL (std::pair<int, int> v)
      {
        return symbol_type (token::CONTROL, std::move (v));
      }
#else
      static
      symbol_type
      make_CONTROL (const std::pair<int, int>& v)
      {
        return symbol_type (token::CONTROL, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MEASURE (std::pair<int, int> v)
      {
        return symbol_type (token::MEASURE, std::move (v));
      }
#else
      static
      symbol_type
      make_MEASURE (const std::pair<int, int>& v)
      {
        return symbol_type (token::MEASURE, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_IDENTITY (std::pair<int, int> v)
      {
        return symbol_type (token::IDENTITY, std::move (v));
      }
#else
      static
      symbol_type
      make_IDENTITY (const std::pair<int, int>& v)
      {
        return symbol_type (token::IDENTITY, v);
      }
#endif


  private:
    /// This class is not copyable.
    Parser (const Parser&);
    Parser& operator= (const Parser&);

    /// Stored state numbers (used for stacks).
    typedef short state_type;

    /// Generate an error message.
    /// \param yystate   the state where the error occurred.
    /// \param yyla      the lookahead token.
    virtual std::string yysyntax_error_ (state_type yystate,
                                         const symbol_type& yyla) const;

    /// Compute post-reduction state.
    /// \param yystate   the current state
    /// \param yysym     the nonterminal to push on the stack
    static state_type yy_lr_goto_state_ (state_type yystate, int yysym);

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool yy_pact_value_is_default_ (int yyvalue);

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool yy_table_value_is_error_ (int yyvalue);

    static const short yypact_ninf_;
    static const signed char yytable_ninf_;

    /// Convert a scanner token number \a t to a symbol number.
    /// In theory \a t should be a token_type, but character literals
    /// are valid, yet not members of the token_type enum.
    static token_number_type yytranslate_ (int t);

    // Tables.
    // YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
    // STATE-NUM.
    static const short yypact_[];

    // YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
    // Performed when YYTABLE does not specify something else to do.  Zero
    // means the default is an error.
    static const unsigned char yydefact_[];

    // YYPGOTO[NTERM-NUM].
    static const short yypgoto_[];

    // YYDEFGOTO[NTERM-NUM].
    static const short yydefgoto_[];

    // YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
    // positive, shift that token.  If negative, reduce the rule whose
    // number is the opposite.  If YYTABLE_NINF, syntax error.
    static const short yytable_[];

    static const short yycheck_[];

    // YYSTOS[STATE-NUM] -- The (internal number of the) accessing
    // symbol of state STATE-NUM.
    static const unsigned char yystos_[];

    // YYR1[YYN] -- Symbol number of symbol that rule YYN derives.
    static const unsigned char yyr1_[];

    // YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.
    static const signed char yyr2_[];


    /// Convert the symbol name \a n to a form suitable for a diagnostic.
    static std::string yytnamerr_ (const char *n);


    /// For a symbol, its name in clear.
    static const char* const yytname_[];
#if YYDEBUG
    // YYRLINE[YYN] -- Source line where rule number YYN was defined.
    static const short yyrline_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yy_reduce_print_ (int r);
    /// Print the state stack on the debug stream.
    virtual void yystack_print_ ();

    /// Debugging level.
    int yydebug_;
    /// Debug stream.
    std::ostream* yycdebug_;

    /// \brief Display a symbol type, value and location.
    /// \param yyo    The output stream.
    /// \param yysym  The symbol.
    template <typename Base>
    void yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const;
#endif

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param yysym     The symbol.
    template <typename Base>
    void yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const;

  private:
    /// Type access provider for state based symbols.
    struct by_state
    {
      /// Default constructor.
      by_state () YY_NOEXCEPT;

      /// The symbol type as needed by the constructor.
      typedef state_type kind_type;

      /// Constructor.
      by_state (kind_type s) YY_NOEXCEPT;

      /// Copy constructor.
      by_state (const by_state& that) YY_NOEXCEPT;

      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol type from \a that.
      void move (by_state& that);

      /// The (internal) type number (corresponding to \a state).
      /// \a empty_symbol when empty.
      symbol_number_type type_get () const YY_NOEXCEPT;

      /// The state number used to denote an empty symbol.
      /// We use the initial state, as it does not have a value.
      enum { empty_state = 0 };

      /// The state.
      /// \a empty when empty.
      state_type state;
    };

    /// "Internal" symbol: element of the stack.
    struct stack_symbol_type : basic_symbol<by_state>
    {
      /// Superclass.
      typedef basic_symbol<by_state> super_type;
      /// Construct an empty symbol.
      stack_symbol_type ();
      /// Move or copy construction.
      stack_symbol_type (YY_RVREF (stack_symbol_type) that);
      /// Steal the contents from \a sym to build this.
      stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) sym);
#if YY_CPLUSPLUS < 201103L
      /// Assignment, needed by push_back by some old implementations.
      /// Moves the contents of that.
      stack_symbol_type& operator= (stack_symbol_type& that);

      /// Assignment, needed by push_back by other implementations.
      /// Needed by some other old implementations.
      stack_symbol_type& operator= (const stack_symbol_type& that);
#endif
    };

    /// A stack with random access from its top.
    template <typename T, typename S = std::vector<T> >
    class stack
    {
    public:
      // Hide our reversed order.
      typedef typename S::reverse_iterator iterator;
      typedef typename S::const_reverse_iterator const_iterator;
      typedef typename S::size_type size_type;
      typedef typename std::ptrdiff_t index_type;

      stack (size_type n = 200)
        : seq_ (n)
      {}

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      const T&
      operator[] (index_type i) const
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      T&
      operator[] (index_type i)
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Steal the contents of \a t.
      ///
      /// Close to move-semantics.
      void
      push (YY_MOVE_REF (T) t)
      {
        seq_.push_back (T ());
        operator[] (0).move (t);
      }

      /// Pop elements from the stack.
      void
      pop (std::ptrdiff_t n = 1) YY_NOEXCEPT
      {
        for (; 0 < n; --n)
          seq_.pop_back ();
      }

      /// Pop all elements from the stack.
      void
      clear () YY_NOEXCEPT
      {
        seq_.clear ();
      }

      /// Number of elements on the stack.
      index_type
      size () const YY_NOEXCEPT
      {
        return index_type (seq_.size ());
      }

      std::ptrdiff_t
      ssize () const YY_NOEXCEPT
      {
        return std::ptrdiff_t (size ());
      }

      /// Iterator on top of the stack (going downwards).
      const_iterator
      begin () const YY_NOEXCEPT
      {
        return seq_.rbegin ();
      }

      /// Bottom of the stack.
      const_iterator
      end () const YY_NOEXCEPT
      {
        return seq_.rend ();
      }

      /// Present a slice of the top of a stack.
      class slice
      {
      public:
        slice (const stack& stack, index_type range)
          : stack_ (stack)
          , range_ (range)
        {}

        const T&
        operator[] (index_type i) const
        {
          return stack_[range_ - i];
        }

      private:
        const stack& stack_;
        index_type range_;
      };

    private:
      stack (const stack&);
      stack& operator= (const stack&);
      /// The wrapped container.
      S seq_;
    };


    /// Stack type.
    typedef stack<stack_symbol_type> stack_type;

    /// The stack.
    stack_type yystack_;

    /// Push a new state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param sym  the symbol
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym);

    /// Push a new look ahead token on the state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the state
    /// \param sym  the symbol (for its value and location).
    /// \warning the contents of \a sym.value is stolen.
    void yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym);

    /// Pop \a n symbols from the stack.
    void yypop_ (int n = 1);

    /// Some specific tokens.
    static const token_number_type yy_error_token_ = 1;
    static const token_number_type yy_undef_token_ = 2;

    /// Constants.
    enum
    {
      yyeof_ = 0,
      yylast_ = 1592,     ///< Last index in yytable_.
      yynnts_ = 69,  ///< Number of nonterminal symbols.
      yyfinal_ = 68, ///< Termination state number.
      yyntokens_ = 107  ///< Number of tokens.
    };


    // User arguments.
    Scanner& scanner;
    quant_c_ast::TranslationUnitNode& prog;
  };


#line 7 "/home/tyler/code/C-C++/QuantC/code/quant_c.y"
} // quant_c_compiler
#line 3240 "quant_c_parse.hpp"





#endif // !YY_YY_QUANT_C_PARSE_HPP_INCLUDED
