#include "symbol_table/symbol_table.hpp"
#include <string>

using namespace symbol_table;

/**************************************************
*  class used to hold information associated w/
*  Symbs (which are stored in SymbolTables)
****************************************************/
SymbolInfo::SymbolInfo(): Symb() {
    this->kind = kind; this->type = type; this->valid = false;
}

SymbolInfo::SymbolInfo(const SymbolInfo& other) : Symb::Symb(other) {
    this->type = other.type;
    this->kind = other.kind;
    this->valid = other.valid;
}

SymbolInfo::SymbolInfo(std::string id, type_info::Kind kind, type_info::Type type): Symb(id) {
    this->kind = kind; this->type = type; this->valid = true;
}

SymbolInfo::SymbolInfo(std::string id, type_info::KindValue kind, type_info::TypeValue type): Symb(id) {
    this->kind = type_info::Kind(kind);
    this->type = type_info::Type(type);
    this->valid = true;
}

/*
SymbolInfo::SymbolInfo(std::string id, quant_c_ast::QuantumContext quantum_context, type_info::KindValue kind, type_info::TypeValue type) :
Symb(id) {
    this->kind = kind; this->type = type; this->valid = true;

    // Determine
}
*/

SymbolInfo::operator std::string() const {
    return "("+ this->get_name() +": kind=" + std::string(kind)+ ", type="+  std::string(type)+")";
};
